<?php
namespace Ric;
defined( 'ABSPATH' ) || exit;


adminAjax::init();

class adminAjax{


    
    private static $instance = null;

    public $ver = '1.0.0';
    public $assetUrl = '';

    public static function init(){
        if ( null == self::$instance ) {
                    self::$instance = new self;
            }
            return self::$instance;
    }



    public function __construct(){ 

        \add_action ( 'wp_ajax_ric_plugin_save_settings', [$this,'saveSettings']);
 

        \add_action ( 'wp_ajax_ric_plugin_sync', [$this,'doSync']);  
        \add_action ( 'wp_ajax_ric_do_crons', [$this,'doCrons']);  
 
    }


    public function doCrons(){

        $crons = Func::getCronsList();

             /*
         * current offset
         */
        $offset = \absint($_POST['offset']); 

        $nextOffset = $offset+1;

        $isDone=false;


        if(!empty($crons[$offset])){

            $theCron = $crons[$offset];

            do_action($theCron);

 


        }else{
            $isDone=true;
        }

        echo \json_encode(['isdone'=>$isDone,'error'=>false,'percent'=>'0','nextoffset'=>$nextOffset]);
    
        die();




    }



    public function doSync(){

        global $_POST;
          
  
        $settings=Func::getOption();
     
        
      
        /*
         * current offset
         */
         $offset = \absint($_POST['offset']); 
        
    
        /*
         * default is not done
         */
        $isDone=false;
        
        
         /* sync taxonomies */
        $typesTax=Func::getOption('sync_tax');
        if($offset===0 && !empty($typesTax) ){
          
    
            //marked tax to sync
            $taxToSync=[];
            foreach($typesTax as $t=>$v){
                if($v=='yes'){
                    $taxToSync[]=$t;
                }
            }
    
            //start sync
            $terms=[];
            if(!empty($taxToSync)){
                foreach($taxToSync as $ts){
                    //find none empty terms
                    $foundTerms = \get_terms( array('taxonomy' => $ts) );
                    if(!empty($foundTerms)){
                        foreach($foundTerms as $foundTerm){
                            $terms[$foundTerm->term_id]=$foundTerm;
                        }
                    }
                } 
            }
    
    
    
            if(!empty($terms)){
                foreach($terms as $term){
                    Func::syncTerm($term,$settings);
                }
            } 
             
        }
    
    
        
    
    
    
        //post types to sync
        $types=Func::getOption('sync');
        
        /*
         * is there types to sync
         */
         if(empty($types)){
             echo \json_encode(['isdone'=>false,'error'=>'true','message'=>esc_html__('No posts types to sync, plese modify plugin settings','ric')]);
             die();
        }
    
    
    
    
        
    
        
        
        /*
         * posts count per post_type
         */
        $allPostToSyncCount=0;
        $selectes=[];
        foreach ($types as $name=>$issync){
            if($issync==='yes'){
                $selectes[]=$name;
                $count_products= \wp_count_posts($name);
                $allPostToSyncCount+=$count_products->publish;
            }
        }
        
         /*
         * verify is there types to sync
         */
         if(empty($selectes)){
             echo \json_encode(['isdone'=>false,'error'=>'true','message'=>esc_html__('No posts types to sync, plese modify plugin settings','ric')]);
             
             die();
        }
           
        
 
        $items_per_sync=$settings['indexing']['items_per_sync'];
       
        
     
    
    
        /*
         * query for selected tyoes
         */
        $args=[];
        $args['offset']=$offset;
        $args['posts_per_page']=$items_per_sync;
        $args['post_type']=$selectes;
        $prs= \get_posts($args);
        if(!empty($prs)){
            foreach ($prs as $pr){
                Func::syncPost($pr,$settings);
            }
            $percent = $offset/intval($allPostToSyncCount)*100;
        }else{



            


             $percent = 100;
               $isDone=true;
        }
        echo \json_encode(['isdone'=>$isDone,'error'=>false,'percent'=>$percent,'nextoffset'=>(\intval($offset)+ \intval($items_per_sync))]);
    
        die();

    }

    public function saveSettings(){
        global $_POST;


        
        if ( ! check_admin_referer( 'ric_nonce', 'ric_nonce' ) ) {
            echo json_encode(['error'=>true,'message'=>__('Invailed request','ricpro'),'html'=>'']);
            die();
        }

        
       
       $data=[];
       
       $sections=Fields::getFieldsSettings();
       foreach ($sections as $section=>$fields){
        foreach ($fields as $field){
            $key=$field['key'];
            $def=$field['def'];
            
            if(!isset($data[$section])){
                $data[$section]=[];
            }
            
            
            if(!empty($_POST[$key])){
                $valToSave  = \wp_kses_post($_POST[$key]);
                
            
            }else{
                  $valToSave  = $def;
                
            }
            
            if($field['type']=='number'){
                $valToSave = \intval($valToSave);

                if(!empty($field['max']) && $valToSave>$field['max']){
                    $valToSave= $field['max'];
                }
            }
         
            
            $data[$section][$key] = $valToSave;

            
        }
       }

      Func::setOption($data);


        $syncHtml = '<div class="ric_sync_modal">';
            $syncHtml.= '<div class="ric_sync_modal_in">';
                $syncHtml.= '<h2>'.esc_html__('Sync in process, please wait!','ric').'</h2>';
                $syncHtml.= Func::getSyncAdmin();
            $syncHtml.='</div>';
        $syncHtml.='</div>';
       
      echo \json_encode(['error'=>false,'message'=>esc_html__('Settings saved, Some of the changes will take a while.','ric'),'synchtml'=>$syncHtml]);
     
          die();
    }
}

 
 