<?php
namespace Ric;
defined( 'ABSPATH' ) || exit;

class Fields{
        
    /**
    * Return admin settings fields
    *
    * @since 1.0.0
    * @param none
    * @return array;
    */
    public static function getFieldsSettings(){
    
        $r=[];
        

            
        $f=[];
        $f['key'] = 'ric_status';
        $f['def'] = 'active_preview';
        $f['type'] = 'select';
        $f['subtype'] = 'none';
        $f['options'] = [
            'active' => esc_html__('Active','ric'),
            'active_preview' => esc_html__('Preview mode','ric')
        ];
        $f['label'] = esc_html__('Status','ric');
        $f['label_row_after'] = '';
        $f['label_row_after'] = esc_html__('When preview mode activated, then you can view the search by include this query in your url','ric').'<code>'.home_url('?ric_prev_mode=true').'</code>';
        $r['general'][]=$f;

        $f=[];
        $f['key'] = 'newtab';
        $f['def'] = 'no';
        $f['type'] = 'checkbox';
        $f['subtype'] = 'none';
        $f['label'] = esc_html__('Open items in a new tab','ric');
        $f['label_row_after'] = '';
        $r['general'][]=$f;


/*

        $f=[];
        $f['key'] = 'active';
        $f['def'] = 'no';
        $f['type'] = 'checkbox';
        $f['subtype'] = 'none';
        $f['label'] = esc_html__('Active','ric');
        $f['label_row_after'] = '';
        $r['general'][]=$f;
        
        $f=[];
        $f['key'] = 'active_preview';
        $f['def'] = 'no';
        $f['type'] = 'checkbox';
        $f['subtype'] = 'none';
        $f['label'] = esc_html__('Preview mode','ric');
        
        $f['label_row_after'] = esc_html__('When preview mode activated, then you can view the search by include this query in your url','ric').'<code>'.home_url('?ric_prev_mode=true').'</code>';
        $r['general'][]=$f;
        */
        $f=[];
        $f['key'] = 'redirect_to_search';
        $f['def'] = 'no';
        $f['type'] = 'checkbox';
        $f['subtype'] = 'none';
        $f['label'] = esc_html__('Show at the bottom of the search drop a link to the search results page','ric');
        $f['label_row_after'] = '';
        $r['general'][]=$f;
        
    
            
        
        $f=[];
        $f['key'] = 'results_to_show';
        $f['def'] = 5;
        $f['type'] = 'number';
        $f['max'] =10;
        $f['subtype'] = 'none';
        $f['label'] = esc_html__('Maximum results limit','ric');
        $f['label_row_after'] = '';
        $f['label_row_after_pro'] = esc_html__('Need more? Free your limit','ric');
        $r['general'][]=$f;
        



        $f=[];
        $f['key'] = 'search_tax_terms';
        $f['def'] = 'no';
        $f['type'] = 'checkbox';
        $f['subtype'] = 'none';
        $f['label'] = esc_html__('Show categories list on search results layout','ric');
        $f['label_row_after'] = '';
        $r['general'][]=$f;


        
    
        $f=[];
        $f['key'] = 'search_tax_terms_count';
        $f['def'] = 5;
        $f['type'] = 'number';
        $f['max'] =5;
        $f['subtype'] = 'none';
        $f['label'] = esc_html__('Maximum categories results limit','ric');
        $f['label_row_after'] = '';
        $f['label_row_after_pro'] = esc_html__('Need more? Free your limit','ric');
        $r['general'][]=$f;


    
        
            
        $f=[];
        $f['key'] = 'show_images';
        $f['def'] = 'no';
        $f['type'] = 'checkbox';
        $f['subtype'] = 'none';
        $f['label'] = esc_html__('Show thumbnails in results','ric');
        $f['label_row_after'] = '';
        $r['thumbnails'][]=$f;
    

            
        $f=[];
        $f['key'] = 'image_fit';
        $f['def'] = 'contain';
        $f['type'] = 'select';
        $f['subtype'] = 'none';
        $f['options'] = [
            'contain' => esc_html__('Displying full image - maintaining its aspect ratio','ric'),
            'cover' => esc_html__("Cover - Displying part of the image",'ric')
        ];
        $f['label'] = esc_html__('How image should be resized to fit its container?','ric');
        $f['label_row_after'] = '';
        $r['thumbnails'][]=$f;

    

        
        
        $f=[];
        $f['key'] = 'woocommerce';
        $f['def'] = 'no';
        $f['type'] = 'checkbox';
        $f['subtype'] = 'none';
        $f['label'] = esc_html__('Woocommerce support active','ric');
        $f['label_row_after'] = '';
        $r['woocommerce'][]=$f;



        $f=[];
        $f['key'] = 'hide_outofstock';
        $f['def'] = 'no';
        $f['type'] = 'checkbox';
        $f['subtype'] = 'none';
        $f['label'] = esc_html__('Hide out of stock items from the search results','ric');
        $f['label_row_after'] = '';
        $r['woocommerce'][]=$f;


        
        
        $f=[];
        $f['key'] = 'addtocart';
        $f['def'] = 'no';
        $f['type'] = 'checkbox';
        $f['subtype'] = 'none';
        $f['label'] = esc_html__('Show add to cart url','ric');
        $f['label_row_after'] = '';
        $r['woocommerce'][]=$f;
        
        $f=[];
        $f['key'] = 'prices';
        $f['def'] = 'no';
        $f['type'] = 'checkbox';
        $f['subtype'] = 'none';
        $f['label'] = esc_html__('Show prices','ric');
        $f['label_row_after'] = '';
        $r['woocommerce'][]=$f;
            

        
        $f=[];
        $f['key'] = 'sku';
        $f['def'] = 'yes';
        $f['type'] = 'checkbox';
        $f['subtype'] = 'none';
        $f['label'] =  esc_html__('Index product SKU','ric');
        $f['label_row_after'] =  '';
        $r['woocommerce'][]=$f;

        
    
        


        /*
            indexing
        */

            
        
        $f=[];
        $f['key'] = 'items_per_sync';
        $f['def'] = 100;
        $f['type'] = 'number';
        $f['subtype'] = 'none';
        $f['label'] = esc_html__('Amount of items to be synced in each automatic or manual request (every 5 min)','ric');
        $f['label_row_after'] = esc_html__('In case of busy site, keep it as lower you can','ric');
        $r['indexing'][]=$f;

        
                
        $f=[];
        $f['key'] = 'indexing_title';
        $f['def'] = 'no';
        $f['type'] = 'checkbox';
        $f['subtype'] = 'none';
        $f['label'] = esc_html__("Post's name sync",'ric');
        $f['label_row_after'] =esc_html__("Will show search results based on the post's name: for example: product name",'ric');
        $r['indexing'][]=$f;

                
    

        $f=[];
        $f['key'] = 'indexing_post_content';
        $f['def'] = 'no';
        $f['type'] = 'checkbox';
        $f['subtype'] = 'none';
        $f['label'] =  esc_html__('Main content in posts','ric');
        $f['label_row_after'] =esc_html__("Will show search results based on content appearing in the visual editor",'ric');
        $r['indexing'][]=$f;



    
        
        $f=[];
        $f['key'] = 'indexing_post_excerpt';
        $f['def'] = 'no';
        $f['type'] = 'checkbox';
        $f['subtype'] = 'none';
        $f['label'] =  esc_html__('Excerpt sync','ric');
        $f['label_row_after'] = esc_html__("Will show search results based on the post's excerpt: for example: product excerpt",'ric');
        $r['indexing'][]=$f;

 
    

        
        $f=[];
        $f['key'] = 'indexing_term_title';
        $f['def'] = 'no';
        $f['type'] = 'checkbox';
        $f['subtype'] = 'none';
        $f['label'] = esc_html__('Categories name sync','ric');
        $f['label_row_after'] = esc_html__("will show results on the categories list based on the category name. For example: Searching the term Chairs will show categories on the categories list that it's name contains the term Chairs.",'ric');
        $r['indexing_tax'][]=$f;

        $f=[];
        $f['key'] = 'indexing_term_description';
        $f['def'] = 'no';
        $f['type'] = 'checkbox';
        $f['subtype'] = 'none';
        $f['label'] =  esc_html__('Categories description sync','ric');
        $f['label_row_after'] =esc_html__('will show results on the categories list based on the category description. For example: Searching the term Chairs will show categories on the categories list that their description contains the term Chairs.','ric');
        $r['indexing_tax'][]=$f;
        
    

    

        

        /* 
        * post types to sync
        */
        $r['sync']=[];
        $post_types = Func::getPostTypes();
        if(!empty($post_types)){
            foreach ($post_types as $post_type){
                if($post_type=='attachment'){
                    continue;
                }
                $f=[];
                $f['key'] = $post_type;
                $f['def'] = 'no';
                $f['type'] = 'checkbox';
                $f['subtype'] = 'none';
                $f['label'] = $post_type;
                $f['label_row_after'] = '';
                $r['sync'][]=$f;
            }
        }

        /* 
        * taxonomies to sync
        */
        $taxonomies = Func::getTaxonomies(); 
        if(!empty($taxonomies)){
            foreach ($taxonomies as $tax){
                $f=[];
                $f['key'] = $tax;
                $f['def'] = 'no';
                $f['type'] = 'checkbox';
                $f['subtype'] = 'none';
                $f['label'] = $tax;
                $f['label_row_after'] = '';
                $r['sync_tax'][]=$f;
            }
        }

        
        
        
        $f=[];
        $f['key'] = 'layout';
        $f['def'] = 'simple';
        $f['type'] = 'select';
        $f['subtype'] = 'none';
        $f['options'] = [
            'simple' => esc_html__('Simple layout','ric'),
        //  'wide' => esc_html__('Wide layout','ric'),
        'modal' => esc_html__('Modal layout','ric')
        ];
        $f['label'] = esc_html__('Search drop layout','ric');
        $f['label_row_after'] = '';
        $r['general'][]=$f;
        /*
        $f=[];
        $f['key'] = 'runfrom';
        $f['def'] = 'focus';
        $f['type'] = 'select';
        $f['subtype'] = 'none';
        $f['options'] = [
            'focus' => esc_html__('Focus on wp native search field. input[name=s]','ric'),
        'click' => esc_html__('Click on button','ric') 
        ];
        $f['label'] = esc_html__('Run search when','ric');
        $f['label_row_after'] = '';
        $r['general'][]=$f;
        $f=[];
        $f['key'] = 'runfrom_selector';
        $f['def'] = 'input[name=s]:not(.adminbar-input)';
        $f['type'] = 'text';
        $f['subtype'] = 'none';
        $f['label'] = esc_html__('Css selector to run search','ric');
        $f['label_row_after'] = '';
        $r['general'][]=$f;*/
        
            /*
        $f=[];
        $f['key'] = 'bad_words';
        $f['def'] = 'sex, drugs, sexy, pussy';
        $f['type'] = 'textarea';
        $f['subtype'] = 'commaseprated';
        $f['label'] = esc_html__('Block terms from show as a popular terms','ric');
        $f['label_row_after'] = esc_html__('(Comma separated, lowercase)','ric');
        $r['miscellaneous'][]=$f;
        */
            
        $f=[];
        $f['key'] = 'search_field_label';
        $f['def'] = 'What you are looking for today?';
        $f['type'] = 'text';
        $f['subtype'] = 'none';
        $f['label'] = esc_html__('Search field label','ric');
        $f['label_row_after'] = '';
        $r['miscellaneous'][]=$f;
        
        




                
        $f=[];
        $f['key'] = 'free_indexingpostscategories';
        $f['ispro'] = true;
        $f['def'] = 'no';
        $f['type'] = 'checkbox';
        $f['subtype'] = 'none';
        $f['label'] =  esc_html__("Name crossing - Crossing a search query with category name in order to display it's items",'ric');
        $f['label_row_after'] =  esc_html__("In addition to the existing search results, this feature shows product search results from the category whose it's named meets the requested term. For example, when searching Beds the system shows products that do not contain the word Beds but their category is Beds",'ric');
        $f['label_row_after_pro'] = esc_html__('Go Primium','ric');
        $r['indexing'][]=$f;


                                
        $f=[];
        $f['key'] = 'free_indexingpostscategoriesaddition';
        $f['ispro'] = true;
        $f['def'] = '';
        $f['type'] = 'textarea';
        $f['subtype'] = 'commaseprated';
        $f['label'] = esc_html__("Index custom taxonomies names (comma seprated)",'ric');
        $f['label_row_after'] = esc_html__("Fill the taxonomy slug key  (Comma separated, recommended to consult an expert)",'ric');
        $f['label_row_after_pro'] = esc_html__('Go Primium','ric');
        $r['indexing'][]=$f;


        $f=[];
        $f['key'] = 'free_imagekey';
        $f['def'] = '_thumbnail_id';
        $f['type'] = 'text';
        $f['ispro'] = true;
        $f['subtype'] = 'none';
        $f['label'] = esc_html__('Custom image field meta key','ric');
        $f['label_row_after'] = '';
        $f['label_row_after_pro'] = esc_html__('Go Primium','ric');
        $r['thumbnails'][]=$f;

        $f=[];
        $f['key'] = 'free_indexingpostmeta';
        $f['ispro'] = true;
        $f['def'] = '';
        $f['type'] = 'textarea';
        $f['subtype'] = 'commaseprated';
        $f['label'] = esc_html__("Index additional meta fields Fill meta field's key names (comma seprated)",'ric');
        $f['label_row_after'] = esc_html__("Fill meta field's key  (Comma separated, recommended to consult an expert)",'ric');
        $f['label_row_after_pro'] = esc_html__('Go Primium','ric');
        $r['indexing'][]=$f;



        $attrs = [];
        $attrs['none']='none';
    //  $taxonomies = ric_get_taxonomies(); 
        if(!empty($taxonomies)){
            foreach ($taxonomies as $tax){
                if(strpos($tax,'pa_')!==false){
                    $attrs[$tax]=$tax;
                }
            }
        }

     /*   $f=[];
        $f['key'] = 'free_colorattribute';
        $f['ispro'] = true;
        $f['def'] = 'none';
        $f['type'] = 'select';
        $f['subtype'] = 'none';
        $f['options'] = $attrs;
        $f['label'] = esc_html__('Color attribute','ric');
        $f['label_row_after'] = '';
        $f['label_row_after_pro'] = esc_html__('Go Primium','ric');
        $r['woocommerce'][]=$f;*/

        $f=[];
        $f['key'] = 'free_orderitems';
        $f['ispro'] = true;
        $f['def'] = 'default';
        $f['type'] = 'select';
        $f['subtype'] = 'none';
        $f['options'] = [
            'default' => esc_html__('Automatic','ric'),
        ];
        $f['label'] = esc_html__('Order items by - Chose the order of the items on the search results layout','ric');
        $f['label_row_after'] = '';
        $f['label_row_after_pro'] = esc_html__('Go Primium','ric');
        $r['general'][]=$f;


        
        /*
        * filter to add more fields
        */
        $r = \apply_filters('ric_settings_fields_array', $r);
        return $r;
    }


    /**
    * Return admin html field
    *
    * @since 1.0.0
    * @param array $args
    * @return string;
    */
    public static function getFieldInput($args){


        if(empty($args['key'])){
            return false;
        }
        if(empty($args['type'])){
            return false;
        }

        $key = wp_kses_data($args['key']);
        $max = !empty($args['max']) ? wp_kses_data($args['max']) : false;
        $val = !empty($args['value']) ? wp_kses_data($args['value']) : false;
        $after = !empty($args['label_row_after']) ? wp_kses_data($args['label_row_after']) : false;
        $afterPro = !empty($args['label_row_after_pro']) ? wp_kses_data($args['label_row_after_pro']) : false;

        $isPro =isset($args['ispro'])&&$args['ispro'];
        $html='Unkown field '.$args['type'];
        switch ($args['type']){
            case 'color':
                $html='<input '.($isPro ? 'disabled' : '').' type="color"  id="ric_field'.$key.'" name="'.$key.'"  '.($val=='yes' ? 'checked' : '').' value="'.($val ? $val : '').'" />';
            break;
            case 'checkbox':
                $html='<input '.($isPro ? 'disabled' : '').' type="checkbox"  id="ric_field'.$key.'" name="'.$key.'"  '.($val=='yes' ? 'checked' : '').' value="yes" />';
            break;
            case 'number':
                $html='<input '.($isPro ? 'disabled' : '').' type="number" '.($max ? 'max="'.$max.'"' : '').' id="ric_field'.$key.'" name="'.$key.'"   value="'.($val ? $val : '0').'" />';
            break;
            case 'text':
                $html='<input '.($isPro ? 'disabled' : '').' type="text"  id="ric_field'.$key.'" name="'.$key.'"   value="'.($val ? $val : '').'" />';
            break;
            case 'textarea':
                $html='<textarea '.($isPro ? 'disabled' : '').'  id="ric_field'.$key.'" name="'.$key.'" >'.($val ? $val : '').'</textarea>';
            break;
            case 'select':
                $html='<select  '.($isPro ? 'disabled' : '').' id="ric_field'.$key.'" name="'.$key.'">';
                foreach ($args['options'] as $k=>$v){
                    $html.='<option '.($val==wp_kses_data($k) ? 'selected' : '').' value="'.wp_kses_data($k).'">'.wp_kses_data($v).'</option>';
                }
                $html.='</select>';
            break;
        }
        $html.='<p>'.$after.'</p>';

        if($afterPro){
            $html.= '<div class="label_row_after_pro">'.\apply_filters('label_row_after_pro', $afterPro).'</div>';
        }
        
        return $html;
    }

}
