<?php
namespace Ric;
defined( 'ABSPATH' ) || exit;


new AdminMenu();

class AdminMenu{

    public function __construct(){
        \add_action('admin_menu', function(){
              /*
                * main menu
                */
                \add_menu_page( esc_html__('Ricerca Search','ric'),
                esc_html__('Ricerca Search','ric'),'manage_options', 'ric_plugin_admin_menu_page', [$this,'mainMenuCb'], 'dashicons-media-spreadsheet' );

            
                /*
                * sync sub menu
                */
                \add_submenu_page(
                        'ric_plugin_admin_menu_page',
                        esc_html__('Sync','ric'), 
                        esc_html__('Sync','ric'), 
                        'manage_options',
                        'ric_plugin_admin_menu_sync',
                        [$this,'syncMenu']
                        );
        });
    }


    public function mainMenuCb(){

    
        $page_type=!empty($_GET['page']) ? wp_kses_post($_GET['page']) :false;
        if(!$page_type || $page_type!='ric_plugin_admin_menu_page'){
                return false;
        }
    
        $opt = Func::getOption();
    
        $tabs=[];
        $tabs[]= [
            'name'=>esc_html__('General','ric'),
            'key'=>'general'
        ];
        $tabs[]= [
            'name'=>esc_html__('Posts indexing options','ric'),
            'key'=>'indexing'
        ];
        $tabs[]= [
            'name'=>esc_html__('Categories results - terms indexing options','ric'),
            'key'=>'indexing_tax'
        ];
        $tabs[]= [
            'name'=>esc_html__('Post types to sync','ric'),
            'key'=>'sync'
        ];
        $tabs[]= [
            'name'=>esc_html__('Taxonomies to sync','ric'),
            'description'=>esc_html__('Example: In case your site has Brands as taxonomy and you would like to show search results of items of a certain brand.','ric'),
            'key'=>'sync_tax'
        ];
        $tabs[]= [
            'name'=>esc_html__('Thumbnails','ric'),
            'key'=>'thumbnails'
        ];
        if ( Func::isWoocommerceActive() ){
            $tabs[]= [
                'name'=>esc_html__('Woocommerce compatibility','ric'),
                'key'=>'woocommerce'
            ];
        } 
        $tabs[]= [
            'name'=>esc_html__('Miscellaneous','ric'),
            'key'=>'miscellaneous'
        ];
         
    
    
        $tabs = \apply_filters('ric_settings_tabs', $tabs);
    
     
        echo '<div class="ric ric_admin_container">';
            echo '<h1>'.esc_html__('Ricerca Search','ric').'</h1>';
            echo '<div class="ric_admin_cols">';
          
            echo '<form class="ric_admin_settings ">';
    
            wp_nonce_field( 'ric_nonce', 'ric_nonce' );
    
           echo '<input type="hidden" name="action" value="ric_plugin_save_settings" />';
              
     
                echo '<div class="metabox-holder ric_tabs">';
    
                echo '<div class="ric_tabs_head">';
                foreach($tabs as $index=>$tab){
                    echo '<a class="ric_tab_toggle '.($index==0 ? 'current' : '').'" href="#ric-tab-'.esc_attr($tab['key']).'">'.esc_attr($tab['name']).'</a>';
                }
            
                do_action('ric_after_settings_tabs');
                 
            echo '</div>';//ric_tabs_head
    
    
      
              
    
                 
                    echo '<div class="ric_tab_content">';
    
    
                        foreach($tabs as $index=>$tab){
                            echo '<div id="ric-tab-'.esc_attr($tab['key']).'" class=" ric_tab_content_item '.($index==0 ? 'current' : '').'">';
                               
                                echo '<h3 class="hndle"><span>'.esc_attr($tab['name']).'</span></h3>';
    
                                if(!empty($tab['description'])){
                                    echo '<p>'.esc_attr($tab['description']).'</p>';
                                }
                                    echo '<div class="ric_grid">';
                                         $fields = Fields::getFieldsSettings();
     
    
                                        $section=esc_attr($tab['key']);
                                        foreach ($fields[$section] as $field){
                                                $key=$field['key'];
                                            echo '<div class="ric_grid_item '.(isset($field['ispro'])&&$field['ispro'] ? 'ric_grid_item_profield' : '').'">';
                                                echo '<div class="ric_grid_item_head">';
                                                    echo '<label for="ric_field'.$key.'">'.$field['label'].'</label>';
                                                echo '</div>';//ric_grid_item_head
                                                echo '<div class="ric_grid_item_content">';
                                                $value= isset($opt[$section][$key]) ? $opt[$section][$key] : $field['def'];
                                                $field['value']=$value;
                                                echo Fields::getFieldInput($field);
                                                echo '</div>';//ric_grid_item_content
                                            echo '</div>';//ric_grid_item
                                        } 
                                    echo '</div>';//ric_grid
    
    
    
                                    echo '<button class="button button-primary button-large">'.esc_html__('Save settings','ric').'</button>';
                                    echo '<a role="button" class="ric_save_and_sync button button-large">'.esc_html__('Save settings and sync','ric').'</a>';
                                echo '<div class="ric_err"></div>';
    
    
    
                                do_action('ric_tab_content_after_button_'.esc_attr($tab['key']));
                                
                        
                            echo '</div>';// ric_tab_content_item
    
                        }
    
    
    
     
                        do_action('ric_after_settings_tabs_content');
    
        
    
     
                            
                    
                        echo '</div>';// ric_tab_content
                  
                 
                     
                      
                    do_action('ric_after_settings_html');
                    
            
    
    
                echo '</div>';//metabox-holder ric_tabs
                
                
                
        
                
            echo '</form>';
     
     
         
    


            ?>
            <div class="ric_mailchimp">
                 <!-- Begin Mailchimp Signup Form -->
<link href="//cdn-images.mailchimp.com/embedcode/classic-071822.css" rel="stylesheet" type="text/css">
<style type="text/css">
	#mc_embed_signup{background:#fff; clear:left; font:14px Helvetica,Arial,sans-serif;  width:280px;}
	/* Add your own Mailchimp form style overrides in your site stylesheet or in this style block.
	   We recommend moving this block and the preceding CSS link to the HEAD of your HTML file. */
</style>
<style type="text/css">
	#mc-embedded-subscribe-form input[type=checkbox]{display: inline; width: auto;margin-right: 10px;}
	#mergeRow-gdpr {margin-top: 20px;}
	#mergeRow-gdpr fieldset label {font-weight: normal;}
	#mc-embedded-subscribe-form .mc_fieldset{border:none;min-height: 0px;padding-bottom:0px;}
</style>
<div id="mc_embed_signup">
    <form action="https://myricerca.us12.list-manage.com/subscribe/post?u=b20b8b84839bc7a1e0cce10a3&amp;id=53dbdee12a&amp;v_id=6825&amp;f_id=00bebde0f0" method="post" id="mc-embedded-subscribe-form" name="mc-embedded-subscribe-form" class="validate" target="_blank" novalidate>
        <div id="mc_embed_signup_scroll">
        <h2>Subscribe </h2>
        <div class="indicates-required"><span class="asterisk">*</span> indicates required</div>
<div class="mc-field-group">
	<label for="mce-FNAME">First Name </label>
	<input type="text" value="" name="FNAME" class="" id="mce-FNAME">
	<span id="mce-FNAME-HELPERTEXT" class="helper_text"></span>
</div>
<div class="mc-field-group">
	<label for="mce-LNAME">Last Name </label>
	<input type="text" value="" name="LNAME" class="" id="mce-LNAME">
	<span id="mce-LNAME-HELPERTEXT" class="helper_text"></span>
</div>
<div class="mc-field-group">
	<label for="mce-EMAIL">Email Address  <span class="asterisk">*</span>
</label>
	<input type="email" value="" name="EMAIL" class="required email" id="mce-EMAIL" required>
	<span id="mce-EMAIL-HELPERTEXT" class="helper_text"></span>
</div>
<div id="mergeRow-gdpr" class="mergeRow gdpr-mergeRow content__gdprBlock mc-field-group">
    <div class="content__gdpr">
        <label>Marketing Permissions</label>
        <p>Please select all the ways you would like to hear from MyRicerca:</p>
        <fieldset class="mc_fieldset gdprRequired mc-field-group" name="interestgroup_field">
		<label class="checkbox subfield" for="gdpr_91057"><input type="checkbox" id="gdpr_91057" name="gdpr[91057]" value="Y" class="av-checkbox gdpr"><span>Email</span> </label>
        </fieldset>
        <p>You can unsubscribe at any time by clicking the link in the footer of our emails. For information about our privacy practices, please visit our website.</p>
    </div>
    <div class="content__gdprLegal">
        <p>We use Mailchimp as our marketing platform. By clicking below to subscribe, you acknowledge that your information will be transferred to Mailchimp for processing. <a href="https://mailchimp.com/legal/terms" target="_blank">Learn more about Mailchimp's privacy practices here.</a></p>
    </div>
</div>
	<div id="mce-responses" class="clear foot">
		<div class="response" id="mce-error-response" style="display:none"></div>
		<div class="response" id="mce-success-response" style="display:none"></div>
	</div>    <!-- real people should not fill this in and expect good things - do not remove this or risk form bot signups-->
    <div style="position: absolute; left: -5000px;" aria-hidden="true"><input type="text" name="b_b20b8b84839bc7a1e0cce10a3_53dbdee12a" tabindex="-1" value=""></div>
        <div class="optionalParent">
            <div class="clear foot">
                <input type="submit" value="Subscribe" name="subscribe" id="mc-embedded-subscribe" class="button">
                <p class="brandingLogo"><a href="http://eepurl.com/irtkhc" title="Mailchimp - email marketing made easy and fun"><img src="https://eep.io/mc-cdn-images/template_images/branding_logo_text_dark_dtp.svg"></a></p>
            </div>
        </div>
    </div>
</form>
</div>
<script type='text/javascript' src='//s3.amazonaws.com/downloads.mailchimp.com/js/mc-validate.js'></script><script type='text/javascript'>(function($) {window.fnames = new Array(); window.ftypes = new Array();fnames[0]='EMAIL';ftypes[0]='email';fnames[1]='FNAME';ftypes[1]='text';fnames[2]='LNAME';ftypes[2]='text';}(jQuery));var $mcj = jQuery.noConflict(true);</script>
<!--End mc_embed_signup-->
           
                </div>
            <?php

echo '</div>';

do_action('ric_after_settings_form');
    
        echo '</div>';//ric_admin_container
    }



    


    /**
    * print sync menu page
    *
    * @since 1.0.0
    * @param none
    * @return none;
    */
    public function syncMenu(){
    

        $page_type=!empty($_GET['page']) ? wp_kses_post($_GET['page']) :false;

        if(!$page_type || $page_type!='ric_plugin_admin_menu_sync'){
                return false;
        }

        $screen = get_current_screen();
        if ( $screen->parent_file != 'ric_plugin_admin_menu_page' )
                return;

            
    
    

        ?>
    <div class="ric_admin_container">
    <?php
    if(!empty($_GET['firstsync'])){

    ?>
    <h1><?php echo esc_html__('Doing first Sync, please wait...','ric'); ?></h1>

    <?php
    }
    
    echo Func::getSyncAdmin();



    if(!empty($_GET['firstsync'])){
        ?>
        <script>
    document.addEventListener('DOMContentLoaded', function () {
        $('.ric_sync_data').trigger('submit');
    
    });
    

    </script><?php
    }
    ?>
    </div>
        <?php
        
        
    }

}


  

